Subject: Re: Bug in git-remote

From: SZEDER Gábor <[email-masked]>
Date: Sat, 15 Dec 2018 14:02:04 +0100

On Sat, Dec 15, 2018 at 02:14:56AM -0500, Gennady Uraltsev wrote:
> I am on git version 2.20.0
> 
> $ git remote
> 
> does not show remotes configured in named files in $GIT_DIR/remotes/
>
> I do not think that this is the intended behavior.

It's a known bug.  When 'git remote' was rewritten as a builtin
command in C in commit 211c89682e (Make git-remote a builtin,
2008-02-29) the parts dealing with remotes under 'GIT_DIR/remotes/'
were not rewritten.  I don't know whether that was intended or not,
but storing remote information as configuration was about two years
old back then.  Given that since then '$GIT_DIR/remotes/' got marked
as "This mechanism is legacy and not likely to be found in modern
repositories", I'm not sure it's worth fixing.  Perhaps it's time for
calling it deprecated.

> In particular:
> 
> $ git init --bare test.git
> Initialized empty Git repository in /home/guraltsev/admin/test/git/test.git/
> 
> $ cd test.git
> 
> $ mkdir -p remotes
> mkdir: created directory 'remotes'
> 
> $ echo -e "URL: /testremote.git \n Push: *:* \n Pull:
> refs/heads/*:refs/remotes/testremote/* " > remotes/testremote
> 
> $ git remote
> 
> $ git remote show testremote
> fatal: '/testremote.git' does not appear to be a git repository
> fatal: Could not read from remote repository.
> 
> Please make sure you have the correct access rights
> and the repository exists.
> 
> 
> 
> The second to last command should show testremote as a remote.
> 
> 
> Best,
> 
> Gennady
>